﻿using JmpPrintService.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace JmpPrintService.Basic
{
    public class JmpTagInit
    {
        public static void JmpPrintEncrypt(string Ver, ref TAG_INFO tag)
        {
            switch (Ver)
            {
                case "00":
                    {
                        tag.TAG_EPC = Ver;
                        break;
                    }
                case "01":
                    {
                        try
                        {
                            tag.TAG_EPC = Ver + Ascii.StringToAscii(PrintDECL.Encrypt(tag.TAG_TID.Substring(12, 12), PrintDECL.Decrypt(Ascii.AsciiToString("6e4274452b682f587467553d"), "202005")));
                        }
                        catch
                        {
                        }
                        break;
                    }
                case "02":
                    {
                        try
                        {
                            tag.TAG_EPC = Ver + Ascii.StringToAscii(PrintDECL.Encrypt(tag.TAG_TID.Substring(12, 12), PrintDECL.Decrypt(Ascii.AsciiToString("705a6241464a52324732673d"), "201314")));
                            // bl = true;
                        }
                        catch (Exception ex)
                        {
                            // bl = false;
                        }
                        break;
                    }
                case "03":
                    {
                        try
                        {
                            tag.TAG_EPC = Ver + Ascii.StringToAscii(PrintDECL.Encrypt(tag.TAG_TID.Substring(16, 12), PrintDECL.Decrypt(Ascii.AsciiToString("705a6241464a52324732673d"), "201314")));
                            // bl = true;
                        }
                        catch (Exception ex)
                        {
                            // bl = false;
                        }
                        break;
                    }
            }

        }
    }

    public class Ascii
    {
        public Ascii()
        {
        }

        public static string StringToAscii(string strInMsg)
        {
            byte[] array = System.Text.Encoding.ASCII.GetBytes(strInMsg);
            string strOutMsg = "";
            foreach (byte b in array)
            {
                int asciicode = (int)b;

                strOutMsg += Convert.ToString(asciicode, 16);
            }
            return strOutMsg;
        }

        public static string AsciiToString(string strInMsg)
        {
            string strOutMsg = "";
            char[] carray = strInMsg.ToCharArray();

            string temp = "";
            List<byte> bList = new List<byte>();
            for (int i = 0; i < carray.Length; i++)
            {
                temp += carray[i].ToString();
                if (i % 2 == 1)
                {
                    int asciicode = Convert.ToInt32(temp, 16);
                    strOutMsg += System.Text.Encoding.ASCII.GetString(new byte[] { (byte)asciicode });
                    temp = "";
                }
            }
            return strOutMsg;
        }
    }

    public class PrintDECL
    {
        public PrintDECL()
        {
        }

        #region 使用 缺省密钥字符串 加密/解密string

        /// <summary>
        /// 使用缺省密钥字符串加密string
        /// </summary>
        /// <param name="original">明文</param>
        /// <returns>密文</returns>
        public static string Encrypt(string original)
        {
            return Encrypt(original, "MATICSOFT");
        }
        /// <summary>
        /// 使用缺省密钥字符串解密string
        /// </summary>
        /// <param name="original">密文</param>
        /// <returns>明文</returns>
        public static string Decrypt(string original)
        {
            return Decrypt(original, "MATICSOFT", System.Text.Encoding.Default);
        }

        #endregion

        #region 使用 给定密钥字符串 加密/解密string
        /// <summary>
        /// 使用给定密钥字符串加密string
        /// </summary>
        /// <param name="original">原始文字</param>
        /// <param name="key">密钥</param>
        /// <param name="encoding">字符编码方案</param>
        /// <returns>密文</returns>
        public static string Encrypt(string original, string key)
        {
            byte[] buff = System.Text.Encoding.Default.GetBytes(original);
            byte[] kb = System.Text.Encoding.Default.GetBytes(key);
            return Convert.ToBase64String(Encrypt(buff, kb));
        }
        /// <summary>
        /// 使用给定密钥字符串解密string
        /// </summary>
        /// <param name="original">密文</param>
        /// <param name="key">密钥</param>
        /// <returns>明文</returns>
        public static string Decrypt(string original, string key)
        {
            return Decrypt(original, key, System.Text.Encoding.Default);
        }

        /// <summary>
        /// 使用给定密钥字符串解密string,返回指定编码方式明文
        /// </summary>
        /// <param name="encrypted">密文</param>
        /// <param name="key">密钥</param>
        /// <param name="encoding">字符编码方案</param>
        /// <returns>明文</returns>
        public static string Decrypt(string encrypted, string key, Encoding encoding)
        {
            byte[] buff = Convert.FromBase64String(encrypted);
            byte[] kb = System.Text.Encoding.Default.GetBytes(key);
            return encoding.GetString(Decrypt(buff, kb));
        }
        #endregion

        #region 使用 缺省密钥字符串 加密/解密/byte[]
        /// <summary>
        /// 使用缺省密钥字符串解密byte[]
        /// </summary>
        /// <param name="encrypted">密文</param>
        /// <param name="key">密钥</param>
        /// <returns>明文</returns>
        public static byte[] Decrypt(byte[] encrypted)
        {
            byte[] key = System.Text.Encoding.Default.GetBytes("MATICSOFT");
            return Decrypt(encrypted, key);
        }
        /// <summary>
        /// 使用缺省密钥字符串加密
        /// </summary>
        /// <param name="original">原始数据</param>
        /// <param name="key">密钥</param>
        /// <returns>密文</returns>
        public static byte[] Encrypt(byte[] original)
        {
            byte[] key = System.Text.Encoding.Default.GetBytes("MATICSOFT");
            return Encrypt(original, key);
        }
        #endregion

        #region  使用 给定密钥 加密/解密/byte[]

        /// <summary>
        /// 生成MD5摘要
        /// </summary>
        /// <param name="original">数据源</param>
        /// <returns>摘要</returns>
        public static byte[] MakeMD5(byte[] original)
        {
            MD5CryptoServiceProvider hashmd5 = new MD5CryptoServiceProvider();
            byte[] keyhash = hashmd5.ComputeHash(original);
            hashmd5 = null;
            return keyhash;
        }


        /// <summary>
        /// 使用给定密钥加密
        /// </summary>
        /// <param name="original">明文</param>
        /// <param name="key">密钥</param>
        /// <returns>密文</returns>
        public static byte[] Encrypt(byte[] original, byte[] key)
        {
            TripleDESCryptoServiceProvider des = new TripleDESCryptoServiceProvider();
            des.Key = MakeMD5(key);
            des.Mode = CipherMode.ECB;

            return des.CreateEncryptor().TransformFinalBlock(original, 0, original.Length);
        }

        /// <summary>
        /// 使用给定密钥解密数据
        /// </summary>
        /// <param name="encrypted">密文</param>
        /// <param name="key">密钥</param>
        /// <returns>明文</returns>
        public static byte[] Decrypt(byte[] encrypted, byte[] key)
        {
            TripleDESCryptoServiceProvider des = new TripleDESCryptoServiceProvider();
            des.Key = MakeMD5(key);
            des.Mode = CipherMode.ECB;

            return des.CreateDecryptor().TransformFinalBlock(encrypted, 0, encrypted.Length);
        }

        #endregion

    }

}
